/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.preferences.ftp;

import fr.cenra.rhomeo.core.RhomeoCore;
import java.io.IOException;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.security.GeneralSecurityException;
import java.util.List;
import java.util.logging.Level;
import java.util.prefs.Preferences;
import javax.annotation.PreDestroy;
import org.apache.commons.net.ftp.FTPClient;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
@Component
@Primary
public class MockFTPPreferences implements FTPPreferences {

    /**
     * A temporary directory to simulate FTP file tree.
     */
    private final Path mockDir;

    private final Preferences mockPreferences;

    protected MockFTPPreferences() throws IOException {
        mockDir = Files.createTempDirectory("mockFTPRhomeo");
        mockPreferences = Preferences.userNodeForPackage(MockFTPPreferences.class);
    }

    @Override
    public FTPAccess getAccess(ACCESS_POINTS ap) {
        return new MockFTPAccess(mockPreferences.node("test_".concat(ap.name())));
    }

    @Override
    public String getPreference(Object key) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void setPreference(Object key, String value) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public List getKeys() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    private class MockFTPAccess extends FTPAccess {

        public MockFTPAccess(Preferences prefs) {
            super(prefs);
        }

        @Override
        public FTPClient createClient() throws IOException, GeneralSecurityException {
            return new MockFTPClient(mockDir);
        }
    }

    @PreDestroy
    private void deleteTempDir() {
        try {
            Files.walkFileTree(mockDir, new SimpleFileVisitor<Path>() {

                @Override
                public FileVisitResult postVisitDirectory(Path dir, IOException exc) throws IOException {
                    Files.delete(dir);
                    return super.postVisitDirectory(dir, exc);
                }

                @Override
                public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
                    Files.delete(file);
                    return super.visitFile(file, attrs);
                }

            });
        } catch (IOException e) {
            RhomeoCore.LOGGER.log(Level.WARNING, "A temporary resource cannot be deleted : ".concat(mockDir.toString()), e);
        }
    }

    @Override
    public int getPriority() {
        return 0;
    }
}